package com.chainway.wsj.activity;

import java.util.List;

import com.chainway.wsj.R;
import com.chainway.wsj.service.SendBroadcastService;
import com.chainway.wsj.thread.Barcode1DThread;
import com.chainway.wsj.thread.Barcode2DSoftThread;
import com.chainway.wsj.thread.Barcode2DThread;
import com.chainway.wsj.thread.BaseThread;
import com.zebra.adc.decoder.Barcode2DWithSoft;

import android.app.ActivityManager;
import android.app.ActivityManager.RunningServiceInfo;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences.Editor;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.util.Log;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.CompoundButton.OnCheckedChangeListener;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TextView;

public class MainActivity extends BaseActivity implements OnClickListener, TextWatcher {

	public static String DEFAULT_ACTION = "com.chainway.broadcast";
	public static String DEFAULT_KEYVALUE = "data";
	public static String DEFAULT_KEYCODE = "139";
	public static String SERVICE_NAME = "com.chainway.wsj.service.SendBroadcastService";
	
	private TextView tv_scan_data;
	private EditText et_broadcastName;
	private EditText et_key_value;
	private EditText et_scan_key;
	private Button btn_default;
	private Button btn_save;
	private CheckBox cb_power;
	private CheckBox cb_service;
	private ImageView iv_clear1, iv_clear2, iv_clear3;

	private Intent it_broadcast; //͹㲥ͼ
	private String broadcaseAction;
	private int keycode = 139; //ɨ谴
	private boolean isScaning = false; //Ƿɨ
	private Intent it_service; //ķ
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		init();
//		instantReader(); //ʵɨͷ
		
	}

	@Override
	protected void onDestroy() {
		// TODO Auto-generated method stub
		super.onDestroy();
	}

	private void init() {

		tv_scan_data = (TextView) findViewById(R.id.tv_scan_data);
		et_broadcastName = (EditText) findViewById(R.id.et_broadcastName);
		et_key_value = (EditText) findViewById(R.id.et_key_value);
		et_scan_key = (EditText) findViewById(R.id.et_scan_key);

		btn_default = (Button) findViewById(R.id.btn_default);
		btn_default.setOnClickListener(this);

		btn_save = (Button) findViewById(R.id.btn_save);
		btn_save.setOnClickListener(this);
		
		iv_clear1 = (ImageView) findViewById(R.id.iv_clear1);
		iv_clear2 = (ImageView) findViewById(R.id.iv_clear2);
		iv_clear3 = (ImageView) findViewById(R.id.iv_clear3);
		iv_clear1.setOnClickListener(this);
		iv_clear2.setOnClickListener(this);
		iv_clear3.setOnClickListener(this);
		
		cb_power = (CheckBox) findViewById(R.id.cb_power);
		cb_power.setOnCheckedChangeListener(new OnCheckedChangeListener() {
			
			@Override
			public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
				// TODO Auto-generated method stub
				if(isChecked) {
					initPowerOn();
					savePowerState(true);
				} else {
					initPowerOff();
					savePowerState(false);
				}
			}
		});
		
		cb_service = (CheckBox) findViewById(R.id.cb_service);
		cb_service.setOnCheckedChangeListener(new OnCheckedChangeListener() {
			
			@Override
			public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
				// TODO Auto-generated method stub
				
				if(et_broadcastName.getText().toString().trim().length() == 0
						|| et_scan_key.getText().toString().trim().length() == 0) {
					toastMessage(R.string.cannot_null);
					cb_service.setChecked(false);
					return;
				}
				
				saveServiceState(isChecked);
				setEnabled(!isChecked);
				if(isChecked) {
					//жϷǷ
					if(!isServiceWork(MainActivity.this, SERVICE_NAME)) {
						if(it_service == null) {
							it_service = new Intent(MainActivity.this, SendBroadcastService.class);
							it_service.setAction("com.chainway.mysend");
						}
						MainActivity.this.startService(it_service);
						
						setSharedPreferences("key_value", et_key_value.getText().toString().trim());
						setSharedPreferences("Keycode", et_scan_key.getText().toString().trim());
						
//						initPowerOn();
					} else {
						toastMessage(R.string.service_is_on);
					}
				} else {
					if(it_service == null) {
						it_service = new Intent(MainActivity.this, SendBroadcastService.class);
					}
					if(stopService(it_service)) {
						toastMessage(R.string.service_off_succ);
					} 
					
//					initPowerOff();
				}
			}
		});
		
		et_broadcastName.addTextChangedListener(this);
		et_key_value.addTextChangedListener(this);
		et_scan_key.addTextChangedListener(this);

		restoreBeforeData(); //ʾϴα
		et_broadcastName.requestFocus(); //ù֮
		
		cb_service.setChecked(getServiceState());

	}

	/**
	 * ɨص
	 */
	public Barcode2DWithSoft.ScanCallback mScanCallback = new Barcode2DWithSoft.ScanCallback() {

		@Override
		public void onScanComplete(int arg0, int arg1, byte[] arg2) {
			// TODO Auto-generated method stub
			if(arg1 < 1) {
				toastMessage(R.string.bardcode_error);
			} else {
				//豸ûɨ赽Ϣ»һֱɨ裬ҪֶԤֹͣɨ
				mReader.stopScan();
				String strData = new String(arg2).trim();
				tv_scan_data.setText(strData);

				if(it_broadcast == null) {
					it_broadcast = new Intent();
				} 
				it_broadcast.setAction(broadcaseAction); //ù㲥
				it_broadcast.putExtra("data", strData); //װ
				sendBroadcast(it_broadcast); //͹㲥
				Log.e("send", "send:" + strData);
			}

			isScaning = false;
		}
	};

	/***
	 * ֻ¼
	 * @param keyCode
	 * @param event
	 * @return
	 */
	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) {

		//¼⵽ɨ谴£ִɨ
//		if (keyCode == keycode) {
//			if (event.getRepeatCount() == 0 && !isScaning) {
//				isScaning = true;
//				scan();
//				mReader.setScanCallback(mScanCallback);
//				return true;
//			} else{
//				return false;
//			}	
//		} else 
			
//		if(keyCode==KeyEvent.KEYCODE_BACK) { //ؼ
//			Intent it = new Intent();
//			it.addCategory(Intent.CATEGORY_HOME);
//			it.setAction(Intent.ACTION_MAIN);
//			startActivity(it);
//		}
		if(keyCode != KeyEvent.KEYCODE_DEL) {
			String keycodeStr = String.valueOf(keyCode);
			View viewFocus = getWindow().getDecorView().findFocus();
			switch (viewFocus.getId()) {
			case R.id.et_scan_key:
				if(et_scan_key.isEnabled()) {
					et_scan_key.setText(keycodeStr);
					et_scan_key.setSelection(keycodeStr.length());
				}
				break;
	
			default:
				break;
			}
		}

		return super.onKeyDown(keyCode, event);
	}

	@Override
	public void onClick(View v) {
		// TODO Auto-generated method stub

		String strBroad = et_broadcastName.getText().toString().trim();
		String strkey = et_scan_key.getText().toString().trim();

		switch (v.getId()) {
		case R.id.iv_clear1: //Ĺ㲥
			et_broadcastName.getText().clear();
			break;
		case R.id.iv_clear2:  //ļֵ
			et_key_value.getText().clear();
			break;
		case R.id.iv_clear3://İ
			et_scan_key.getText().clear();
			break;
		case R.id.btn_default: //ָĬ
			getDefaultData();
			saveBroadcastAndKeycode(); //ָĬϺ󱣴
			break;
		case R.id.btn_save: //
			if(!TextUtils.isEmpty(strBroad) && !TextUtils.isEmpty(strkey)) {
				saveBroadcastAndKeycode();  //
			} else {
				toastMessage(R.string.cannot_null);
			}
			break;

		default:
			break;
		}
	}

	/**
	 * 㲥ͺͰ
	 */
	private void saveBroadcastAndKeycode() {
		Editor editor = spf.edit();
		editor.putString("BroadcastAction", et_broadcastName.getText().toString().trim());
		setSharedPreferences("key_value", et_key_value.getText().toString().trim());
		editor.putString("Keycode", et_scan_key.getText().toString().trim());
		if(editor.commit()) {
			toastMessage(R.string.action_succeed);
			broadcaseAction = spf.getString("BroadcastAction", DEFAULT_ACTION);
			keycode = Integer.parseInt(spf.getString("Keycode", DEFAULT_KEYCODE)); // ȡرɨ谴
		} else {
			toastMessage(R.string.action_fail);
		} 
//		setSharedPreferences("etErDsKeyCode", et_scan_key.getText().toString().trim());
	}
	/**
	 * ָϴαĹ㲥ͺͰ
	 */
	private void restoreBeforeData() {
		String strBoast = spf.getString("BroadcastAction", DEFAULT_ACTION);
		String key_value = spf.getString("key_value", DEFAULT_KEYVALUE);
		String strkey = spf.getString("Keycode", DEFAULT_KEYCODE);
		et_broadcastName.setText(strBoast);
		et_key_value.setText(key_value);
		et_scan_key.setText(strkey);
		
		et_broadcastName.setSelection(strBoast.length());
		et_key_value.setSelection(key_value.length());
		et_scan_key.setSelection(strkey.length());
	}
	
	/**
	 * ָĬ
	 */
	private void getDefaultData() {
		
		et_broadcastName.setText(DEFAULT_ACTION);
		et_key_value.setText(DEFAULT_KEYVALUE);
		et_scan_key.setText(DEFAULT_KEYCODE);

		et_broadcastName.setSelection(DEFAULT_ACTION.length());
		et_key_value.setSelection(DEFAULT_KEYVALUE.length());
		et_scan_key.setSelection(DEFAULT_KEYCODE.length());

		try {
			broadcaseAction = DEFAULT_ACTION;
			keycode = Integer.parseInt(DEFAULT_KEYCODE); //ȡرɨ谴
		} catch(NumberFormatException e) {
			keycode = 139;
		}
	}

	/**
	 * ȫְɨ
	 */
	private void initPowerOn() {
		Barcode2DThread b2t = new Barcode2DThread(getApplicationContext(), null, BaseThread.ACTION_DEVICE_ON);
		b2t.start();
		
		Barcode2DSoftThread b2st = new Barcode2DSoftThread(getApplicationContext(), null, BaseThread.ACTION_DEVICE_ON);
		b2st.start();

		Barcode1DThread b1t = new Barcode1DThread(getApplicationContext(), null, BaseThread.ACTION_DEVICE_ON);
		b1t.start();
		
	}

	/**
	 * رȫְɨ
	 */
	private void initPowerOff() {
		
        Barcode2DThread b2t = new Barcode2DThread(getApplicationContext(), null, BaseThread.ACTION_DEVICE_OFF);
        b2t.start();
        
        Barcode2DSoftThread b2st = new Barcode2DSoftThread(getApplicationContext(), null, BaseThread.ACTION_DEVICE_OFF);
        b2st.start();

        Barcode1DThread b1t = new Barcode1DThread(getApplicationContext(), null, BaseThread.ACTION_DEVICE_OFF);
        b1t.start();
	}
	
	/**
	 * ȫְɨ״̬
	 * @param state
	 */
	private void savePowerState(boolean state) {
		Editor editor = spf.edit();
		editor.putBoolean("isPowerOn", state);
		editor.commit();
	}
	
	/**
	 * ȡȫְɨǷ
	 * @return
	 */
	private boolean getPowerState() {
		return spf.getBoolean("isPowerOn", false);
	}
	

	/**
	 * ȫְɨ״̬
	 * @param state
	 */
	private void saveServiceState(boolean state) {
		Editor editor = spf.edit();
		editor.putBoolean("isServiceOn", state);
		editor.commit();
	}
	
	/**
	 * ȡȫְɨǷ
	 * @return
	 */
	private boolean getServiceState() {
		return spf.getBoolean("isServiceOn", false);
	}
	
	private void setEnabled(boolean enabled) {
		et_broadcastName.setEnabled(enabled);
		et_key_value.setEnabled(enabled);
		et_scan_key.setEnabled(enabled);
		btn_default.setEnabled(enabled);
		btn_save.setEnabled(enabled);
		iv_clear1.setEnabled(enabled);
		iv_clear2.setEnabled(enabled);
		iv_clear3.setEnabled(enabled);
	}

	@Override
	public void afterTextChanged(Editable s) {
		// TODO Auto-generated method stub
		if(s == et_broadcastName.getEditableText()) {
			if(s.toString().length() > 0) {
				iv_clear1.setVisibility(View.VISIBLE);
			} else {
				iv_clear1.setVisibility(View.GONE);
			}
		} else if(s == et_key_value.getEditableText()) {
			if(s.toString().length() > 0) {
				iv_clear2.setVisibility(View.VISIBLE);
			} else {
				iv_clear2.setVisibility(View.GONE);
			}
		} else if(s == et_scan_key.getEditableText()) {
			if(s.toString().length() > 0) {
				iv_clear3.setVisibility(View.VISIBLE);
			} else {
				iv_clear3.setVisibility(View.GONE);
			}
		}
	}

	@Override
	public void beforeTextChanged(CharSequence s, int start, int count, int after) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void onTextChanged(CharSequence s, int start, int before, int count) {
		// TODO Auto-generated method stub
		
	}
	

	/** 
	* жĳǷеķ 
	*  
	* @param mContext 
	* @param serviceName 
	*            ǰ+磺net.loonggg.testbackstage.TestService 
	* @return trueУfalseû 
	*/  
	public boolean isServiceWork(Context mContext, String serviceName) {  
		boolean isWork = false;  
		ActivityManager myAM = (ActivityManager) mContext  
				.getSystemService(Context.ACTIVITY_SERVICE);  
		List<RunningServiceInfo> myList = myAM.getRunningServices(myAM.getRunningAppProcesses().size()); 

		if (myList.size() <= 0) {  
			return false;  
		}  
		for (int i = 0; i < myList.size(); i++) {  
			String mName = myList.get(i).service.getClassName().toString();  
			if (mName.equals(serviceName)) {  
				isWork = true;  
				break;  
			}  
		}  
		return isWork;  
	} 

}
