package com.chainway.wsj.service;

import com.chainway.wsj.R;
import com.chainway.wsj.activity.MainActivity;
import com.zebra.adc.decoder.Barcode2DWithSoft;

import android.app.Activity;
import android.app.Service;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.SharedPreferences;
import android.os.IBinder;
import android.util.Log;
import android.widget.EditText;
import android.widget.Toast;

public class SendBroadcastService extends Service {
	public static String TAG = "SendBroadcastService";
	private String KEYDOWN_ACTION = "com.rscja.android.KEY_DOWN"; //ɨʱܹ㲥action
	private MyBroadReceiver bc;
	private Barcode2DWithSoft mReader;
	private Intent it_broadcast; //͹㲥ͼ
	private boolean isOpen = false; //ɨģǷѾϵ
	private boolean isScaning = false; //Ƿɨ
	private SharedPreferences spf;
	@Override
	public void onCreate() {
		// TODO Auto-generated method stub
		super.onCreate();
		Log.i(TAG, "onCreate");

		instantReader();
		
		spf = getSharedPreferences("myData", Activity.MODE_PRIVATE);
		
		bc = new MyBroadReceiver();
		IntentFilter filter = new IntentFilter(KEYDOWN_ACTION);
		registerReceiver(bc, filter);
	}
	
	@Override
	public IBinder onBind(Intent arg0) {
		// TODO Auto-generated method stub
		return null;
	}
	
	@Override
	public int onStartCommand(Intent intent, int flags, int startId) {
		// TODO Auto-generated method stub
		Log.i(TAG, "onStartCommand");
		return START_REDELIVER_INTENT;
//		return super.onStartCommand(intent, flags, startId);
	}
	
	@Override
	public void onStart(Intent intent, int startId) {
		// TODO Auto-generated method stub
		Log.i(TAG, "onStart");
		super.onStart(intent, startId);
	}
	
	@Override
	public void onDestroy() {
		// TODO Auto-generated method stub
		super.onDestroy();
		if(bc != null) {
			unregisterReceiver(bc);
			bc = null;
		}
		
		//رɨͷ
		if(mReader != null) {
			isOpen = false;
			mReader.close();
			mReader = null;
		}
	}
	
	public class MyBroadReceiver extends BroadcastReceiver {
		public MyBroadReceiver() {
			// TODO Auto-generated constructor stub
			super();
		}
		@Override
		public void onReceive(Context context, Intent intent) {
			// TODO Auto-generated method stub
			String keycode = intent.getIntExtra("keycode", 0) + "";
			Log.i("KeyBroadcastReceiver", "յ㲥 keycode=" + intent.getIntExtra("keycode", 0) + " action=" + intent.getAction());
			if (!isScaning && spf.getString("Keycode", MainActivity.DEFAULT_KEYCODE).equals(keycode)) { //õɨһ
				isScaning = true;
				scan();
				if(mReader != null) {
					mReader.setScanCallback(mScanCallback);
				}
			}
		}

	}
	
	/**
	 * ɨص
	 */
	public Barcode2DWithSoft.ScanCallback mScanCallback = new Barcode2DWithSoft.ScanCallback() {

		@Override
		public void onScanComplete(int arg0, int arg1, byte[] arg2) {
			// TODO Auto-generated method stub
			String strData = "";
			isScaning = false;
			
			if(arg1 < 1) {
				Log.e(TAG, getString(R.string.bardcode_error));
				strData = getString(R.string.bardcode_error);
			} else {
				//豸ûɨ赽Ϣ»һֱɨ裬ҪֶԤֹͣɨ
				mReader.stopScan();
				strData = new String(arg2).trim();

				if(it_broadcast == null) {
					it_broadcast = new Intent();
				} 
			}
			it_broadcast.setAction(spf.getString("BroadcastAction", MainActivity.DEFAULT_ACTION)); //ù㲥
			it_broadcast.putExtra(spf.getString("key_value", MainActivity.DEFAULT_KEYVALUE), strData); //װ
			sendBroadcast(it_broadcast); //͹㲥
			Log.i("send", "send:" + strData);
		}
	};
	
	/**
	 * ִɨ
	 */
	public void scan() {
		if(mReader == null) {
			isScaning = false;
			return;
		}

		//ģϵ
		if(!isOpen) {
			isOpen = mReader.open(this); 
		}
		
		if(isOpen) {
			//ɨͷò
			mReader.setParameter(324, 1);
			mReader.setParameter(300, 0);
			mReader.setParameter(361, 0);
		} else {
			Log.e(TAG, getString(R.string.open_fail));
			return;
		}
		
		//ɨӿڣɨͨصд
        mReader.scan();
	}
	
	public void instantReader() {
		try {
			//ʵͷӿ
			mReader = Barcode2DWithSoft.getInstance();

		} catch (Exception ex) {
			Log.e(TAG, ex.getMessage());
		}
	}
}
