package com.chainway.wsj.thread;

import android.content.Context;
import android.content.Intent;
import android.os.Looper;
import android.util.Log;

import com.rscja.deviceapi.Barcode1D;
import com.rscja.deviceapi.exception.ConfigurationException;

public class Barcode1DThread extends BaseThread {

    private Barcode1D barcode;


    public Barcode1DThread(Context context, Intent intent, int action) {
        super(context, intent, action);
    }


    @Override
    public void run() {
        super.run();
        Looper.prepare();


        try {
            if (barcode == null) {
                barcode = Barcode1D.getInstance();
            }
        } catch (ConfigurationException e) {
            e.printStackTrace();

            return;
        }

        if (mAction == ACTION_DEVICE_ON) {
            barcode.close();
            try {
                sleep(500);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
            barcode.open();
            Log.i("Barcode1DThread", "barcode open");
        } else if (mAction == ACTION_DEVICE_OFF) {
            barcode.close();
            Log.i("Barcode1DThread", "barcode close");

        } else if (mAction == ACTION_DEVICE_STOP_SCAN) {
            Log.i("Barcode1DThread", "barcode Stop Scan");
            barcode.stopScan();
        } else {
            Log.i("Barcode1DThread", "barcode scan");
            data = barcode.scan();
            playSound();

            sendToTarget();
        }


        Looper.loop();
    }

}
