package com.chainway.wsj.thread;

import com.zebra.adc.decoder.Barcode2DWithSoft;

import android.content.Context;
import android.content.ContextWrapper;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Looper;
import android.util.Log;

public class Barcode2DSoftThread extends BaseThread {

    private Barcode2DWithSoft barcode;
    private Context myContext;

    public Barcode2DSoftThread(Context context, Intent intent, int action) {
        super(context, intent, action);
        myContext=context;

        Log.i("Barcode2DSoftThread", "barcode instance id="+Thread.currentThread().getId());

    }

    public Barcode2DWithSoft.ScanCallback mScanCallback = new Barcode2DWithSoft.ScanCallback() {
        @Override
        public void onScanComplete(int i, int length, byte[] dt) {

            Log.i("Barcode2DWithSoftThread", "onScanComplete()");

            if (length < 1) {
                data = null;
            } else {
                data = new String(dt,0,length);
            }


            if (barcode != null) {
                barcode.stopScan();

            }
            playSound();

            sendToTarget();

        }
    };

    @Override
    public void run() {
        super.run();

        Looper.prepare();

        Log.i("Barcode2DWithSoftThread", "barcode run");


        if (barcode == null)
        barcode = Barcode2DWithSoft.getInstance();

        if (mAction == ACTION_DEVICE_ON) {
            barcode.open(mContext);
//            barcode.setParameter(298,0);
//            barcode.setParameter(35,0);
//            barcode.setParameter(41,0);

         //   barcode.setParameter(324, 1);
         //   barcode.setParameter(300, 0); // Snapshot Aiming
         //   barcode.setParameter(361, 0); // Image Capture Illumination
         //   鑾峰彇鎵弿閰嶇疆鍙傛暟锛岃繘琛岃缃�
         //   AppConfig config = AppConfig.getAppConfig(MainActivity.myContext);
         //   String Parameter1=config.get(AppConfig.barcode2DParameter1);
         //    String Parameter2=config.get(AppConfig.barcode2DParameter2);

            try
            {
//                 String Parameter11 =getSharedPreferences_String(barcode2DParameter11);
//                 String Parameter12 =getSharedPreferences_String(barcode2DParameter12);
//                 String Parameter21 =getSharedPreferences_String(barcode2DParameter21);
//                 String Parameter22 =getSharedPreferences_String(barcode2DParameter22);
//                 String Parameter31 =getSharedPreferences_String(barcode2DParameter31);
//                 String Parameter32 =getSharedPreferences_String(barcode2DParameter32);
//                 if(Parameter11!=""&&Parameter12!="")
//                 {
//                    barcode.setParameter(Integer.parseInt(Parameter11),Integer.parseInt(Parameter12));
//                 }
//                if(Parameter21!=""&&Parameter22!="")
//                {
//                    barcode.setParameter(Integer.parseInt(Parameter21),Integer.parseInt(Parameter22));
//                }
//                if(Parameter31!=""&&Parameter32!="")
//                {
//                    barcode.setParameter(Integer.parseInt(Parameter31),Integer.parseInt(Parameter32));
//                }
            }
            catch(Exception e)
            {
                Log.i("Barcode2DWithSoftThread", "淇濆锛");
            }
            Log.i("Barcode2DWithSoftThread", "barcode open");
        } else if (mAction == ACTION_DEVICE_OFF) {
            barcode.close();
            Log.i("Barcode2DWithSoftThread", "barcode close");

        } else if (mAction == ACTION_DEVICE_STOP_SCAN) {
            Log.i("Barcode2DWithSoftThread", "barcode Stop Scan");
            barcode.stopScan();
        } else {


            Log.i("Barcode2DWithSoftThread", "barcode scan");


            if (barcode == null) {
                return;
            }

            barcode.setScanCallback(mScanCallback);
            barcode.scan();

        }
        Looper.loop();
    }

    public String getSharedPreferences_String(String key) {
        ContextWrapper test=(ContextWrapper) myContext;
        SharedPreferences preferences = test.getSharedPreferences("KeyboardHelper",
                Context.MODE_PRIVATE);
        return preferences.getString(key, "");
    }

    public void setSharedPreferences(String key, String value) {
        ContextWrapper test=(ContextWrapper) myContext;
        SharedPreferences preferences = test.getSharedPreferences("KeyboardHelper",
                Context.MODE_PRIVATE);
        SharedPreferences.Editor editor = preferences.edit();
        editor.putString(key, value);
        editor.commit();
    }

}
