package com.chainway.wsj.thread;

import android.content.Context;
import android.content.Intent;
import android.os.Looper;
import android.util.Log;

import com.rscja.deviceapi.Barcode2D;
import com.rscja.deviceapi.exception.ConfigurationException;

public class Barcode2DThread extends BaseThread {

    private Barcode2D barcode;

    public Barcode2DThread(Context context, Intent intent, int action) {
        super(context, intent, action);

        Log.i("Barcode2DThread", "barcode instance");

    }


    @Override
    public void run() {
        super.run();

        Looper.prepare();

        Log.i("Barcode2DThread", "barcode run");


        try {
            if (barcode == null)
                barcode = Barcode2D.getInstance();
        } catch (ConfigurationException e) {
            e.printStackTrace();

            return;
        }

        if (mAction == ACTION_DEVICE_ON) {
            barcode.open();
            Log.i("Barcode2DThread", "barcode open");
        } else if (mAction == ACTION_DEVICE_OFF) {
            barcode.close();
            Log.i("Barcode2DThread", "barcode close");

        } else if (mAction == ACTION_DEVICE_STOP_SCAN) {
            Log.i("Barcode2DThread", "barcode Stop Scan");
            barcode.stopScan();
        } else {
            Log.i("Barcode2DThread", "barcode scan");
            // barcode.open();
            data = barcode.scan();

            // barcode.close();

            playSound();

            sendToTarget();


        }
        Looper.loop();
    }

}
