package com.chainway.wsj.thread;

import android.content.ClipData;
import android.content.ClipboardManager;
import android.content.Context;
import android.content.Intent;
import android.util.Log;

public class BaseThread extends Thread {
    protected String data;

    protected Context mContext;
//    protected SoundManager soundManager;
    protected boolean mEnter;
    protected boolean mTab;
    private String mPerfix;
    private String mSuffix;
    private int mTarget;

    public static final int ACTION_DEVICE_ON = 1;
    public static final int ACTION_DEVICE_OFF = 2;
    public static final int ACTION_DEVICE_SCAN = 3;
    public static final int ACTION_DEVICE_STOP_SCAN = 4;
    
	public final static String barcode2DParameter11="2DSParameter11";   //2Dò1-1
	public final static String barcode2DParameter12="2DSParameter12";   //2Dò1-2
	public final static String barcode2DParameter21="2DSParameter21";   //2Dò2-1
	public final static String barcode2DParameter22="2DSParameter22";   //2Dò2-2
	public final static String barcode2DParameter31="2DSParameter31";   //2Dò2-1
	public final static String barcode2DParameter32="2DSParameter32";   //2Dò2-2

    protected int mAction = ACTION_DEVICE_SCAN;


    public BaseThread(Context context, Intent intent, int action) {
        mContext = context;
//        soundManager = SoundManager.getInstance(mContext);

        if (intent != null) {
            mEnter = intent.getBooleanExtra("enter", false);
            mTab = intent.getBooleanExtra("tab", false);
            mPerfix = intent.getStringExtra("prefix");
            mSuffix = intent.getStringExtra("suffix");
            mTarget = intent.getIntExtra("target", 0);
        }
        mAction = action;
    }

    protected void playSound() {
        Log.i("BaseThread", "playSound() data=" + data);

        if (data != null && data.length() > 0) {
//            soundManager.playSound(1);
        } else {
//            soundManager.playSound(2);
        }
    }

    protected void sendToTarget() {
        switch (mTarget) {
            case 0:
                sendToKey();
                break;
            case 1:
                sendToClipboard();
                break;
            default:
                sendToKey();
        }

    }

    private void sendToKey() {
        if (data != null && data.length() > 0) {
            Intent intent = new Intent();
            intent.setAction("com.rscja.android.DATA_RESULT");

//            data=data.trim();

            if (mPerfix != null && mPerfix.length() > 0) {
                data = mPerfix + data;
            }

            if (mSuffix != null && mSuffix.length() > 0) {
                data = data + mSuffix;
            }

            if (mEnter) {
                data += "\n";
            }
            if (mTab) {
                data += "\t";

            }
            intent.putExtra("data", data);
            mContext.sendBroadcast(intent);

        }
    }

    private void sendToClipboard() {

        if (data != null && data.length() > 0) {

            if (mPerfix != null && mPerfix.length() > 0) {
                data = mPerfix + data;
            }

            if (mSuffix != null && mSuffix.length() > 0) {
                data = data + mSuffix;
            }

            if (mEnter) {
                data += "\n";
            }
            if (mTab) {
                data += "\t";

            }

            Log.i("BaseThread", "sendToClipboard()");


//			Looper.prepare();
//
//			ClipboardManager cmb = (ClipboardManager) mContext
//					.getSystemService(Context.CLIPBOARD_SERVICE);
//			cmb.setText(data);

            ClipboardManager clipboardManager = (ClipboardManager) mContext.getSystemService(Context.CLIPBOARD_SERVICE);
            clipboardManager.setPrimaryClip(ClipData.newPlainText(null, data));


//            Toast.makeText(mContext, R.string.msg_clipboard_succ,
//                    Toast.LENGTH_SHORT).show();

//			Looper.loop();
        }

    }
}
